package GUI;

import javafx.application.Application;
import javafx.scene.control.Alert;
import javafx.scene.layout.Region;
import javafx.stage.Stage;

/**
 * Creates Help alerts
 */
public class HelpMessage extends Application {

    private static Alert alert;
    private int n;

    public void start(Stage primaryStage, int n) throws Exception {
        alert = new Alert(Alert.AlertType.INFORMATION);
        setHelpMessage(n);
        start(primaryStage);
    }

    @Override
    public void start(Stage primaryStage) throws Exception {
        alert.setTitle("Help");
        alert.setHeaderText(null);
        alert.getDialogPane().setMinHeight(Region.USE_PREF_SIZE);
        alert.showAndWait();
    }

    private static void setHelpMessage(int n) {
        switch (n) {
            case 1:
                alert.setContentText("EMAIL_ADDRESSES\nContains a comma-separated list of email addresses to which email " +
                        "alerts will be sent.");
                break;
            case 2:
                alert.setContentText("HOSTNAME\nDefines the hostname of the machine on which psad is running. This will " +
                        "be used in the email alerts generated by psad.");
                break;
            case 3:
                alert.setContentText("HOME_NET\nDefine the internal network(s) that are connected to the local system. " +
                        "This will be used in the signature matching code to determine whether traffic matches snort " +
                        "rules, which invariably contain a source and destination network. Multiple networks are " +
                        "supported as a comma separated list, and each network should be specified in CIDR notation. " +
                        "Normally the network(s) contained in the HOME_NET variable should be directly connected to the " +
                        "machine that is running psad.");
                break;
            case 4:
                alert.setContentText("EXTERNAL_NET\nDefine the set of external networks. The default value is \"any\"," +
                        " but it can be set to an arbitrary list of networks, similar to the HOME_NET variable. For most" +
                        " setups, the default is probably best.");
                break;
            case 5:
                alert.setContentText("IMPORT_OLD_SCANS\nIf set to \"Y\" instructs psad to import any old scan data in " +
                        "/var/log/psad from a previously running psad process. This allows scan data to persist across " +
                        "restarts of psad or even a system reboot. The default value for IMPORT_OLD_SCANS is \"N\".");
                break;
            case 6:
                alert.setContentText("FW_SEARCH_ALL\nControl how psad will parse iptables messages.  If it is set to " +
                        "\"Y\" then psad will parse all iptables messages for evidence of scan activity.  If it is set " +
                        "to \"N\" then psad will only parse those iptables messages that contain logging prefixes " +
                        "specified by the FW_MSG_SEARCH variable below. Logging prefixes are set with the --log-prefix " +
                        "command line option to iptables. Setting FW_SEARCH_ALL to \"N\" is useful for having psad only " +
                        "analyze iptables messages that are logged out of a specific iptables chain (multiple strings " +
                        "can be searched for, see the comment above the FW_MSG_SEARCH variable below) or a specific " +
                        "logging rule for example. FW_SEARCH_ALL is set to \"Y\" by default since usually people want " +
                        "psad to parse all iptables messages.");
                break;
            case 7:
                alert.setContentText("FW_MSG_SEARCH\nCan be modified to look for logging messages that are " +
                        "specific to your firewall configuration (specified by the \"--log-prefix\" option. For example," +
                        " if your firewall uses the string \"Audit\" for packets that have been blocked, then you could " +
                        "set FW_MSG_SEARCH to \"Audit\";  The default string to search for is \"DROP\".  Both psad and " +
                        "kmsgsd reference this file.  NOTE: You can specify this variable multiple times to have psad " +
                        "search for multiple strings.");
                break;
            case 8:
                alert.setContentText("SYSLOG_DAEMON\nSet the type of syslog daemon that is used. Psad supports three " +
                        "different syslog daemons: syslogd, syslog-ng, and metalog. One of these maybe specified as an " +
                        "argument to the SYSLOG_DAEMON keyword. The default is \"syslogd\".");
                break;
            case 9:
                alert.setContentText("IGNORE_PORTS\nDefine a set TCP and/or UDP ports that psad should ignore even if " +
                        "suspicious traffic is logged over these ports. Both port ranges and individual TCP and UDP " +
                        "ports can be specified. This keyword adds a degree of configurability to psad in an effort to " +
                        "compensate for an iptables policy that may not be ideally configured (i.e. generating logs for " +
                        "traffic it shouldn't), or for applications such as port knocking schemes (see: fwknop) that " +
                        "generate traffic that is essentially indestinguishable from port scans. The default value for " +
                        "IGNORE_PORTS is \"NONE\".");
                break;
            case 10:
                alert.setContentText("ENABLE_PERSISTENCE\nControl whether or not psad will allow scans to timeout. The " +
                        "default value is \"Y\", which means that scans will never timeout. This is useful for catching " +
                        "scans that take place over long periods of time where the attacker is trying to slip beneath " +
                        "the IDS detection thresholds.");
                break;
            case 11:
                alert.setContentText("SCAN_TIMEOUT\nDefine the number of seconds psad will use to timeout scans (or " +
                        "other suspect traffic) associated with individual IP addresses. The default value is 3600 " +
                        "seconds (one hour). Note the SCAN_TIMEOUT is only used if ENABLE_PERSISTENCE is set to \"N\".");
                break;
            case 12:
                alert.setContentText("DANGER_LEVEL{1,2,3,4,5}\nSet the number of packets that must be seen in order to " +
                        "reach each danger level. Psad supports five danger levels, with 1 being the least severe and 5 " +
                        "being most severe. Scans are assigned a danger level based upon the thresholds defined by the " +
                        "DANGER_LEVEL{1,2,3,4,5} variables. Scans may also be assigned a danger level if a specific " +
                        "signature is matched (see: /etc/psad/signatures) or if the IP address from which the scan " +
                        "originates is automatically assigned a danger level (see: /etc/psad/auto_dl).");
                break;
            case 13:
                alert.setContentText("PSADWATCHD_CHECK_INTERVAL\nSet the number of seconds psad sleeps before checking " +
                        "for new iptables log messages. The default is 5 seconds.");
                break;
            case 14:
                alert.setContentText("PORT_RANGE_SCAN_THRESHOLD\nDefine the minimum range of ports that must be scanned " +
                        "before an email alert will be generated. For example, setting PORT_RANGE_SCAN_THRESHOLD to 1 " +
                        "would require that at least two different ports must be scanned before an alert is sent " +
                        "(i.e. an alert will not be generated if multiple scan packets are sent against the same port). " +
                        "Setting PORT_RANGE_SCAN_THRESHOLD to 0 is the most verbose setting and will cause psad to send " +
                        "alerts for any scan that involves at least the number of packets specified by DANGER_LEVEL1, " +
                        "even if such a scan only involves a single port. The default value for " +
                        "PORT_RANGE_SCAN_THRESHOLD is 1.");
                break;
            case 15:
                alert.setContentText("SHOW_ALL_SIGNATURES\nIf set to \"Y\" instructs psad to either include all scan " +
                        "signatures associated with an IP address in every new email alert for the IP. Note that this " +
                        "may result in long email alerts if an IP is persistantly hitting your site with suspicious " +
                        "traffic over a long period of time. SHOW_ALL_SIGNATURES is set to \"N\" by default and hence " +
                        "psad will only display alert information associate with new signatures.");
                break;
            case 16:
                alert.setContentText("SNORT_SID_STR\nInstruct psad to for snort \"sid\" values generated by fwsnort or " +
                        "snort2iptables in iptables logging prefixes. The default is \"SID\" since fwsnort generates " +
                        "iptables logs that contain strings such as \"SID940\".");
                break;
            case 17:
                alert.setContentText("ENABLE_DSHIELD_ALERTS\nIf set to \"Y\" will allow psad to send scan data to the " +
                        "DShield distributed IDS. Security data is usually considered sensitive by system " +
                        "administrators so ENABLE_DSHIELD_ALERTS is set to \"N\" by default, but DShield genuienly " +
                        "provides a useful service to people who are concerned about network security and so enabling " +
                        "this feature is helpful to the community. See dshield.org for more information.");
                break;
            case 18:
                alert.setContentText("DSHIELD_ALERT_EMAIL\nDefine the email address to which DShield alerts will be " +
                        "sent if DShield alerting is enabled (see the ENABLE_DSHIELD_ALERTS keyword). The default " +
                        "value is \"reports@dshield.org\" and should only be changed if the DShield reporting " +
                        "address changes.");
                break;
            case 19:
                alert.setContentText("DSHIELD_ALERT_INTERVAL\nDefine the number of hours between successive DShield " +
                        "email alerts that are generated by psad. The default value is 6 hours, but should not be set " +
                        "to anything less than 1 hour or greater than 24 hours. This keyword is only referenced if " +
                        "DShield alerting is enabled (see the ENABLE_DSHIELD_ALERTS keyword).");
                break;
            case 20:
                alert.setContentText("DSHIELD_USER_ID\nIs used to define a DShield user id (requires free registration " +
                        "at dshield.org). The default is \"0\" which allows psad to send scan information to the " +
                        "DShield distributed IDS anonymously (that is in the sense that the scan data will not be " +
                        "associated with any particular DShield user id). This keyword is only referenced if DShield " +
                        "alerting is enabled (see the ENABLE_DSHIELD_ALERTS keyword).");
                break;
            case 21:
                alert.setContentText("DSHIELD_USER_EMAIL\nDefine the source email address that will be used to send " +
                        "scan data to the DShield distributed IDS. The default is \"NONE\" which allows psad to send " +
                        "scan information to DShield from the same source email address that is used by psad to send " +
                        "normal scan alerts. This keyword is only referenced if DShield alerting is enabled (see the " +
                        "ENABLE_DSHIELD_ALERTS keyword).");
                break;
            case 22:
                alert.setContentText("DSHIELD_DL_THRESHOLD\nDefine a threshold danger level before scan data will be " +
                        "included in email alerts to DShield. The default is \"0\" since this will allow DShield to " +
                        "apply its own logic to determine what constitutes a scan (i.e. _all_ iptables log messages " +
                        "will be included in DShield email alerts with DSHIELD_DL_THRESHOLD set to \"0\"). This " +
                        "keyword is only referenced if DShield alerting is enabled (see the ENABLE_DSHIELD_ALERTS " +
                        "keyword).");
                break;
            case 23:
                alert.setContentText("IGNORE_CONNTRACK_BUG_PKTS\nInstruct psad to ignore TCP packets that have the " +
                        "ACK bit set. The reason for this stems from the fact that the TCP connection tracking code " +
                        "in the Linux kernel sets an inappropriately short timeout for acknowledgement packets " +
                        "associated with TCP sessions that have entered the CLOSE WAIT state. Note that TCP packets " +
                        "that trip application level inspection signatures as detected by fwsnort will still be " +
                        "alerted upon by psad since fwsnort generates iptables logging prefixes such as \"SID940\" " +
                        "which are parsed first by psad. The default value for IGNORE_CONNTRACK_BUG_PKTS is \"Y\".");
                break;
            case 24:
                alert.setContentText("ALERT_ALL\nIf set to \"Y\" instructs psad to send email alerts for any new " +
                        "suspect traffic from a particular IP address instead of just when the IP reaches a new danger " +
                        "level. The default for ALERT_ALL is \"Y\"");
                break;
            case 25:
                alert.setContentText("EMAIL_LIMIT\nDefine the maximum number of emails that will be sent for an " +
                        "individual IP address. The default is \"0\" which instructs psad to not set any limit for " +
                        "the number of email alerts that it will send for a particular IP address. Normally if an IP " +
                        "is causing psad to generate hundreds of alert emails there is a misconfiguration in either " +
                        "the iptables policy or in the manner in which the network is being utilized by the IP. Note " +
                        "that enabling this feature by setting PSAD_EMAIL_LIMIT to some value greater than \"0\" may " +
                        "cause alerts for real attacks to not be generated if an attack is sent after the email " +
                        "threshold has been reached for an IP address.");
                break;
            case 26:
                alert.setContentText("EMAIL_ALERT_DANGER_LEVEL\nDefine the minimum danger level a scan must reach " +
                        "before an email alert will be generated by psad. The default value for " +
                        "EMAIL_ALERT_DANGER_LEVEL is \"1\".");
                break;
            case 27:
                alert.setContentText("ENABLE_AUTO_IDS\nIf set to \"Y\" instructs psad to automatically block IP " +
                        "addresses from which scans or other suspect traffic originate. The default is \"N\" since " +
                        "enabling this feature may cause network connectivity problems if the underlying iptables " +
                        "policy is not tuned correctly (for example if it is logging legitmate DNS response traffic), " +
                        "or if an attacker discovers that the auto-blocking feature is enabled and then proceeds to " +
                        "spoof scans from your favorite websites or your upstream router. Psad supports " +
                        "\"whitelisting\" IP addresses via the file /etc/psad/auto_dl so that psad will never add " +
                        "block rules for IP addresses listed in this file that have an auto-danger level set to " +
                        "\"0\". Incidently the /etc/psad/auto_dl file can also be used to automatically elevate the " +
                        "danger level associated with a scan that originates from a specific IP address and/or " +
                        "IP contained within a matching network.");
                break;
            case 28:
                alert.setContentText("AUTO_IDS_DANGER_LEVEL\nSet a threshold on the minimum danger level a scan must " +
                        "reach before psad will automatically block the offending IP address (ENABLE_AUTO_IDS must be " +
                        "set to \"Y\" for this keyword to be used). The default is \"5\" which is the highest danger " +
                        "level assigned by psad to any scan.");
                break;
            case 29:
                alert.setContentText("AUTO_BLOCK_TIMEOUT\nDefine the length of time that an auto-generated block rule " +
                        "will remain in effect (ENABLE_AUTO_IDS must be set to \"Y\" for this keyword to be used). " +
                        "The default is \"3600\" seconds (one hour).");
                break;
            case 30:
                alert.setContentText("IPTABLES_BLOCK_METHOD\nInstruct psad to block IP addresses with iptables (if " +
                        "ENABLE_AUTO_IDS is set to \"Y\"). Blocking via iptables is more effective and more secure than " +
                        "blocking via tcpwrappers since packets are intercepted in the kernel before having an " +
                        "opportunity to talk to any user-land daemon, and hence this is the preferred method of " +
                        "constructing auto-blocking rules. The default value for IPTABLES_BLOCK_METHOD is \"Y\".");
                break;
            case 31:
                alert.setContentText("TCPWRAPPERS_BLOCK_METHOD\nInstruct psad to block IP addresses with tcpwrappers " +
                        "(if ENABLE_AUTO_IDS is set to \"Y\"). Blocking via tcpwrappers is less effective than using " +
                        "iptables directly (see the IPTABLES_BLOCK_METHOD keyword above), so the default value for " +
                        "TCPWRAPPERS_BLOCK_METHOD is \"N\".");
                break;
            case 32:
                alert.setContentText("WHOIS_TIMEOUT\nDefine the timeout that psad will use when issuing whois lookups " +
                        "against scanning IP addresses. The default is 60 seconds. Note that whois lookups can be " +
                        "disabled altogether via the --no-whois command line argument.");
                break;
            case 33:
                alert.setContentText("WHOIS_LOOKUP_THRESHOLD\nDefine the number of times a scanning IP address can be " +
                        "seen before an additional whois lookup will be issued. The motivation for this keyword comes " +
                        "from the fact that IP to whois information mappings will not change very often. The default " +
                        "value for WHOIS_LOOKUP_THRESHOLD is 20. Note that whois lookups can be disabled altogether " +
                        "via the --no-whois command line argument.");
                break;
            case 34:
                alert.setContentText("DNS_LOOKUP_THRESHOLD\nDefine the number of times a scanning IP address can be " +
                        "seen before an additional reverse DNS lookup will be issued. The motivation for this keyword " +
                        "comes from the fact that IP to host DNS mappings will not change very often. The default " +
                        "value for DNS_LOOKUP_THRESHOLD is 20. Note that reverse DNS lookups can be disabled " +
                        "altogether via the --no-rdns command line argument.");
                break;
            case 35:
                alert.setContentText("ENABLE_EXT_SCRIPT_EXEC\nIntructs psad to execute an external script when a scan " +
                        "is detected. This feature is disabled by default; use at your own risk!");
                break;
            case 36:
                alert.setContentText("EXTERNAL_SCRIPT\nDefine an external program to run after a scan is caught. Note " +
                        "that the scan source ip can be specified on the command line to the external program through " +
                        "the use of the \"SRCIP\" string (along with some appropriate switch for the program). Of " +
                        "course this is only useful if the external program knows what to do with this information.\n" +
                        "Example: EXTERNAL_SCRIPT /path/to/script --ip SRCIP -v;");
                break;
            case 37:
                alert.setContentText("EXEC_EXT_SCRIPT_PER_ALERT\nControl execution of EXTERNAL_SCRIPT (only once per " +
                        "IP, or every time a scan is detected for an ip).");
                break;
        }
    }
}
